% evalpol.m
% evaluation de l interpole de Lagrange 
% fd, 09 janvier, 8 octobre  2006.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  function f=evalpol(n,newt,xx,x) ; 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
q=zeros(n+1,1) ; 
q(1:1,1)=newt(n+1:n+1,1) ; 
q(2:2,1)=newt(n:n,1) + (x-xx(n:n,1))*q(1:1,1) ; 

if (n==1) ; q(3:3,1)=0 ; else ; 
q(3:3,1)=newt(n-1:n-1,1) + (x-xx(n-1:n-1,1))*q(2:2,1) ; end ; 

for k=2:n+1 ;  j=n+2-k ; 
q(k:k,1) = newt(j:j,1) + (x-xx(j:j,1))*q(k-1:k-1,1) ; 
end ; 
f = q(n+1:n+1,1) ; 


