% interpol04.m
% interpolation de Lagrange 
% fd, agreg, 08 octobre 2006 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
xlabel (' interpol04. Polynome d interpolation  de Lagrange ') ;
ylabel ('') ;
%  n  nombre de donnees brutes ; c est un nombre d intervalles...
nex = 100 ; dxex = 3*pi  / nex  ;
xex =zeros(nex+1 , 1) ; yex =zeros(nex+1 , 1) ; 
for j=1:nex+1 ; xx =  (j-1)*dxex ;   
xex (j:j , 1) = xx ; 
yex (j:j , 1) = sin(xx) ; end 
hold off ;
axis ( [ -.1 , 3*pi+.1 , -1.1 , 1.5  ]) ;
plot(xex,yex,"g;fonction sinus;") ;  

n=16; 
x =zeros(n+1 , 1) ; 
u0=zeros(n+1 , 1) ; 
dx =  3*pi  / n ;
for j=1:n+1 ; xx = (j-1)*dx ;  
x (j:j , 1) = xx ;
u0(j:j , 1) =  sin(xx) ; end 
hold on ; if (n==1) ;  
plot(x,u0(:,1),"*;donnees;",x,u0(:,1),"b;interpolation affine;") ; \
  else 
plot(x,u0(:,1),"*;;",x,u0(:,1),"b;;")
end
%   pause ; 

 
%                        interpolation de Lagrange 'home made' 
newt=diffdiv(n,x,u0) ; 


nn=300 ;  dy=3*pi/nn ; poly=zeros(nn+1,1) ; 
xx =zeros(nn+1, 1) ; 
for j=1:nn+1 ; xxx =  (j-1)*dy ;
xx (j:j , 1) = xxx ; end ;  
for k=1:nn+1 ; 
poly(k:k,1)=evalpol(n,newt,x,xx(k)) ;
end ; 

%             utilisation des fonctions usuelles de matlab  
[P, S] = polyfit (x, u0, n) ; 
nn=300 ;  dy=3*pi/nn ; 
xx =zeros(nn+1, 1) ; 
for j=1:nn+1 ; xxx =  (j-1)*dy ;
xx (j:j , 1) = xxx ; end ;  

yy=polyval(P,xx) ; 
hold on ;   
plot(xx,yy ,"r;polyfit et polyval : interpolation de Lagrange;") ; 
plot(xx,poly ,"b;interpolation de Lagrange home made;") ; 

